import os
import tkinter as tk
from tkinter import filedialog

def print_message(mtext):
    popwd=tk.Tk()

    popwd.title('Error!')

    tk.Label(popwd,text=mtext,bg='white').pack()
    tk.Button(popwd,text='Ok',width=1,height=1,bg='grey',font=("Courier", 10), \
              command=popwd.destroy).pack()

    popwd.configure(background='white')

    popwd.mainloop()

#save configure parameters to a file
def save_dir(opendir,conf_file,band,binwd,ioflag,plottp,compa,V0f,combin,corx,symm):
    fpath=opendir.get_dirname()
    if len(fpath) < 2:
        return -1

    fwd=open(conf_file,"w")
    fwd.write(fpath+'\n')
    fwd.write(band.get()+'\n')
    fwd.write(binwd.get()+'\n')
    fwd.write(ioflag.get()+'\n')
    fwd.write(plottp.get()+'\n')
    fwd.write(compa.get()+'\n')
    fwd.write(V0f.get()+'\n')
    fwd.write(combin.get()+'\n')
    fwd.write(corx.get()+'\n')
    fwd.write(symm.get())
    fwd.close()

#close botton action function
class close_button():
    def __init__(self, wd, opendir, conf_file, band, binwd, ioflag, plottp, \
        compa, V0f, combin, corx, symm):
        self.wd=wd
        self.opendir=opendir
        self.conf_file=conf_file
        self.band=band
        self.binwd=binwd
        self.ioflag=ioflag
        self.plottp=plottp
        self.compa=compa
        self.V0f=V0f
        self.combin=combin
        self.corx=corx
        self.symm=symm

    def clean_close(self):
        save_dir(self.opendir,self.conf_file,self.band,self.binwd,self.ioflag,
                 self.plottp,self.compa,self.V0f,self.combin,self.corx,self.symm)

        self.wd.destroy()

class directory_dialog():
    def __init__(self,fdir):
        self.init_dir=fdir
        self.fpath=fdir

    def select_dir(self):
        self.fpath=filedialog.askdirectory(initialdir=self.init_dir, \
                                           title="Choose a director.")
        if len(self.fpath) == 0:
            print_message("No file is choosen or exists")
            return -1

    def get_dirname(self):
        return self.fpath

def about_message():
    popwd=tk.Tk()
    popwd.geometry('270x230')
    popwd.title('About')
    tk.Frame(popwd,width=270,height=230,bg="",bd=0,highlightbackground="blue", \
             highlightcolor="blue",highlightthickness=5).place(x=0,y=0)

    tk.Label(popwd, text='',bg='white').pack()
    tk.Label(popwd, text='DSX STATISTIC ANALYSIS',bg='white').pack()
    tk.Label(popwd, text='Version 1.0',bg='white').pack()
    tk.Label(popwd, text='',bg='white').pack()
    tk.Label(popwd, text='Author: Jiannan Tu',bg='white').pack()
    tk.Label(popwd, text='2019',bg='white').pack()
    tk.Label(popwd, text='',bg='white').pack()
    tk.Label(popwd, text='Space Science Laboratory',bg='white').pack()
    tk.Label(popwd, text='University of Massachusetts Lowell',bg='white').pack()
    tk.Label(popwd, text='',bg='white').pack()

    btn=tk.Button(popwd,text='Ok',width=1,height=1,bg='grey',font=("Courier", 10), \
                  command=popwd.destroy)
    btn.place(x=125,y=192)

    popwd.configure(background='white')

    popwd.mainloop()

class save_cfg():
    def __init__(self, opendir, conf_file, band, binwd, ioflag, plottp, compa, \
        V0f, combin, corx, symm):
        self.opendir=opendir
        self.conf_file=conf_file
        self.band=band
        self.binwd=binwd
        self.ioflag=ioflag
        self.plottp=plottp
        self.compa=compa
        self.V0f=V0f
        self.combin=combin
        self.corx=corx
        self.symm=symm

    def save_config(self):
        save_dir(self.opendir,self.conf_file,self.band,self.binwd,self.ioflag, \
            self.plottp,self.compa,self.V0f,self.combin,self.corx,self.symm)

class file_dialog():
    def __init__(self,init_dir,filen):
        self.init_dir=init_dir
        self.filen=filen

    def open_file(self):
        fname=filedialog.askopenfilename(initialdir=self.init_dir.strip(), \
              filetypes =(("Text File", "*.txt .dat"),("All Files","*.*")), \
              title = "Choose a file.")

        self.filen=fname

########################################################################
