import os
import def_classes

def dsx_orbit(fpath):
    fname=[]

    pos=fpath.rfind('/')
    fpath=fpath[0:pos+1]
    if fpath[len(fpath)-1] == '/':
        fpath=fpath+'DSX_orbit'
    else:
        fpath=fpath+'/DSX_orbit'

    for rootp, dirn, fn in os.walk(fpath):
        for files in fn:
            if '_EPH_01' in files:
                fname.append(os.path.join(rootp,files))

    nf=len(fname)
    if nf == 0:
        def_classes.print_message('No orbit files in directory: '+fpath \
            +' Try to use exisitng inside_pp.dat file')
        return -1

    fname.sort()

    fpp=fpath+'/inside_pp.dat'

    fout=open(fpp,'w')
    fout.write(' date     UTin   UTout   PP_Flag\n')

    for i in range(0,nf):
        with open(fname[i], 'r') as fid:
            for j in range(0,19):     #remove headers
                fid.readline()

            #read all the other lines from the file
            fl=fid.readlines()
            fid.close()

        date=[]
        ts=[]
        inout=[]

        nfl=len(fl)
        for j in range(nfl):
            a=fl[j].split()

            if j % 4 == 0:
                date.append(a[1])
                hr=int(a[2][0:2])
                mm=int(a[2][2:4])
                ss=int(a[2][4:6])
                ts.append(hr*60.0+mm+ss/60.0)
            elif j % 4 == 1:
                inout.append(int(a[23]))

        tin=-1.0
        tout=-1.0
        tpp=-1.0
        tend=0.0
        for j in range(len(ts)):
            if inout[j] == 1 and (j == 0 or (j > 0 and \
                (inout[j-1] == 2 or inout[j-1] == 3))):
                tin=ts[j]
            elif j > 0 and (inout[j] == 2 or inout[j] == 3) and inout[j-1] == 1:
                if tin >= 0.0:
                    #print(date[j],tin,ts[j])
                    fout.write(date[j-1]+('{:8.2f}'*2).format(tin,ts[j]) \
                               +('{:4d}'*2).format(inout[j-1],inout[j])+'\n')
                tin=-1.0
                tend=ts[j]

            if inout[j] == 2 and (j == 0 or (j > 0 and \
                (inout[j-1] == 1 or inout[j-1] == 3))):
                tout=ts[j]
            elif j > 0 and (inout[j] == 1 or inout[j] == 3) and inout[j-1] == 2:
                if tout >= 0.0:
                    #print(date[j],tout,ts[j])
                    fout.write(date[j-1]+('{:8.2f}'*2).format(tout,ts[j]) \
                               +('{:4d}'*2).format(inout[j-1],inout[j])+'\n')
                tout=-1.0
                tend=ts[j]

            if inout[j] == 3 and (j == 0 or (j > 0 and \
                (inout[j-1] == 1 or inout[j-1] == 2))):
                tpp=ts[j]
            elif j > 0 and (inout[j] == 1 or inout[j] == 2) and inout[j-1] == 3:
                if tpp >= 0.0:
                    #print(date[j],tpp,ts[j])
                    fout.write(date[j-1]+('{:8.2f}'*2).format(tpp,ts[j]) \
                               +('{:4d}'*2).format(inout[j-1],inout[j])+'\n')
                tpp=-1.0
                tend=ts[j]

        #if tend < 1439.0:
        #    print(date[0],tend,1439.0)
            #fout.write(date[0]+('{:8.2f}'*2).format(tend,1439.0) \
            #           +('{:4d}'*2).format(inout[1439],inout[1439])+'\n')

    fout.close()

    print('Finished processing DSX orbit files')

    return 0