import numpy as np
import math
from scipy import stats

try:
    from matplotlib.backends.backend_tkagg import FigureCanvasTkAgg as figtk
except ImportError:
    from matplotlib.backends.backend_tkagg import FigureCanvasTk as figtk

try:
    from matplotlib.backends.backend_tkagg import NavigationToolbar2TkAgg as navitk
except ImportError:
    from matplotlib.backends.backend_tkagg import NavigationToolbar2Tk as navitk

from mpl_toolkits.axes_grid1.inset_locator import inset_axes

import numpy as np
import math
from scipy import stats

try:
    from matplotlib.backends.backend_tkagg import FigureCanvasTkAgg as figtk
except ImportError:
    from matplotlib.backends.backend_tkagg import FigureCanvasTk as figtk

try:
    from matplotlib.backends.backend_tkagg import NavigationToolbar2TkAgg as navitk
except ImportError:
    from matplotlib.backends.backend_tkagg import NavigationToolbar2Tk as navitk

from mpl_toolkits.axes_grid1.inset_locator import inset_axes

#implement th edefault matplotlib key bindings
import matplotlib.ticker as ticker
from matplotlib.backend_bases import key_press_handler
from matplotlib.figure import Figure
from matplotlib.ticker import MultipleLocator

import matplotlib.pyplot as plt
from matplotlib.ticker import AutoMinorLocator

#####################################################################################
#####################################################################################
#-------------------- plot Ra, Ca, and Prad only for Y + and Y- ---------------------------
def plot_p_RaCaPrad(wd, canv, fig, toolbar, fpath, bwd, L, bname, inpflag, \
    V0, comb, corx):

    print('Read calculated antenna parameters ...')
    fdir=fpath.strip()
    inpflag=inpflag.strip()
    if fdir[len(fdir)-1] == '/':
        if comb == 'Yes':
            datafile=fdir+'All-Bands_InOut_data_comb.dat'
        else:
            datafile=fdir+'All-Bands_InOut_data.dat'
    else:
        if comb == 'Yes':
            datafile=fdir+'/All-Bands_InOut_data_comb.dat'
        else:
            datafile=fdir+'/All-Bands_InOut_data.dat'

    with open(datafile,'r') as dataf:
        dataf.readline()
        dataf.readline()

        fl=dataf.readlines()

        dataf.close()

    print('Finished reading data')

    nrecd=len(fl)

#------------ make plots on the tkinter window -----------------------------
    #clear figure if it exists
    if fig != None:
        fig.clf()
        
    #clear canvas if it exists
    if canv != None:
        canv.get_tk_widget().destroy()

    fig=Figure(figsize=(2.5,1.95),dpi=400)

    canv = figtk(fig, master=wd)
    canv.draw()
    canv.get_tk_widget().place(x=0,y=48)

    if toolbar != 0:
        toolbar.destroy()

    toolbar=navitk(canv, wd)
    toolbar.update()

    def on_key_press(event):
        key_press_handler(event, canv, toolbar)
        canv.mpl_connect("key_press_event", on_key_press)

    #set size, resolution, and position of axes
    xL=[0.08,0.08,0.08,0.53,0.53,0.53]
    yB=[0.66,0.41,0.16,0.66,0.41,0.16]
    wh=[0.43,0.43,0.43,0.43,0.43,0.43]
    ht=[0.23,0.23,0.23,0.23,0.23,0.23]

    if comb == 'Yes':
        ndata=1
        nplt=3
    else:
        ndata=2
        nplt=6

    axes=[]

    for i in range(nplt):
        axes.append(fig.add_axes([xL[i], yB[i], wh[i], ht[i]]))
        fig.add_axes(axes[i])

    #set line width of axes
    for ax in ['left','bottom','right','top']:
        for i in range(nplt):
            axes[i].spines[ax].set_linewidth(0.3)

    sL1='$L_1$ = '+str("{0:.4f}".format(L))+' H'
    if bname == 'All-Bands':
        sL1=''
    if V0 == 9696:
        sL1=sL1+' V1 >= 96 V'
    elif V0 == 8080:
        sL1=sL1+' V1 >= 80 V'

    if bname == 'All-Bands':
        if comb == 'Yes':
            if corx == 'Ca':
                minCX=200.0
                maxCX=500.0
            else:
                minCX=10
                maxCX=600
            minRa=0.1
            maxRa=400
            minPr=0.2
            maxPr=200.0
            if V0 == 8080:
                minRa=0.1
                maxRa=400
                minPr=1
                maxPr=200.0
        else:
            if corx == 'Ca':
                minCX=400.0
                maxCX=900.0
            else:
                minCX=7
                maxCX=200
            minRa=0.03
            maxRa=60
            minPr=0.1
            maxPr=50.0
            if V0 == 8080:
                minRa=0.1
                maxRa=50
                minPr=0.7
                maxPr=50.0
    elif bname == 'High-Band':
        if corx == 'Ca':
            minCX=400.0
            maxCX=700.0
        else:
            minCX=18
            maxCX=27
        minRa=0.2
        maxRa=3.0
        minPr=10
        maxPr=100.0
    elif bname == 'Mid-Band':
        if corx == 'Ca':
            minCX=450.0
            maxCX=850.0
        else:
            minCX=18
            maxCX=27
        minRa=0.2
        maxRa=10.0
        if corx == 'Ca':
            minCX=450.0
            maxCX=900.0
        else:
            minCX=18
            maxCX=27
        minRa=0.3
        maxRa=40.0
        minPr=0.2
        maxPr=6.0

    pi=math.pi
    pi2=2.0*pi
    LL=[0.0375, 0.3015, 2.1515]

    date=[]
    fres=[[],[]]
    CaXa=[[],[]]
    Ra=[[],[]]
    pw=[[],[]]

    diff=0
    for k in range(0,nrecd):
        a=fl[k].split()
        datet=a[0]
        L1=float(a[3])
        inpl=int(a[24])

        if V0 == 9696 and float(a[2]) < 96.0:
            print('Driving voltage is < ',96)
            diff=diff+1
            continue
        elif V0 == 8080 and float(a[2]) < 80.0:
            print('Driving voltage is < ',80)
            diff=diff+1
            continue

        if bname == 'High-Band':
            if L1 > 8.0*LL[0]:
                print('Exclude other bands:',('{:7.4f}'*2).format(L1,L)+ \
                    ' '+datet+' '+a[1])
                diff=diff+1
                continue
        elif bname == 'Mid-Band':
            if L1 < 0.02*LL[1] or L1 > 5.0*LL[0]:
                print('Exclude other bands:',('{:7.4f}'*2).format(L1,L)+ \
                    ' '+datet+' '+a[1])
                diff=diff+1
                continue
        elif bname == 'Low-Band':
            if L1 < 0.5*LL[2]:
                print('Exclude other bands:',('{:7.4f}'*2).format(L1,L)+ \
                    ' '+datet+' '+a[1])
                diff=diff+1
                continue

        if inpflag != 'InOut':
            if inpflag == 'In': #skip if not in plasmasphere
                if inpl == 0 or inpl == 2 or inpl == 3:
                    print('Out of the plasmasphere:','{:2d}'.format(inpl)+ \
                        ' '+datet+' '+a[1])
                    diff=diff+1
                    continue
            else:
                if inpl == 1:  #skip if in the plasmasphere
                    print('In the plasmasphere:','{:2d}'.format(inpl)+ \
                        ' '+datet+' '+a[1])
                    diff=diff+1
                    continue

        if comb == 'Yes':
            fqp=float(a[18])
            Ra1=float(a[19])
            Ca1=float(a[20])
            Ia1=float(a[22])*1.0e-3
            prad1=0.5*Ia1**2*Ra1        # Power in W

            fqm=fqp
            Ra2=Ra1
            Ca2=Ca1
            prad2=prad1
        else:
            fqp=float(a[5])
            fqm=float(a[16])
            Ra1=float(a[9])                        #Ra in Ohm
            Ra2=float(a[20])

            if (fqp > 6.0e3 and Ra1 > 2.5e4) or (fqm > 6.0e3 and Ra2 > 2.5e4):
                diff=diff+1
                continue

            Ca1=float(a[11])            # antenna Ca in pF
            Ca2=float(a[22])
            Ia1=float(a[8])*1.0e-3      # Ia in A
            Ia2=float(a[19])*1.0e-3
            prad1=0.5*Ia1**2*Ra1        # Power in W
            prad2=0.5*Ia2**2*Ra2

        if corx == 'Xa':
            # measured antenna reactance +/- branches in Ohm
            Xa1=1.0e12/(pi2*fqp*Ca1)
            Xa2=1.0e12/(pi2*fqm*Ca2)

            CaXa[0].append(Xa1/1.0e3)
            CaXa[1].append(Xa2/1.0e3)
        else:
            CaXa[0].append(Ca1)
            CaXa[1].append(Ca2)

        date.append(datet)

        fres[0].append(fqp/1.0e3)      #frequency in kHz
        Ra[0].append(Ra1/1.0e3)        #in kilo Ohm
        pw[0].append(prad1)

        fres[1].append(fqm/1.0e3)
        Ra[1].append(Ra2/1.0e3)
        pw[1].append(prad2)

    #end 'for loop' for calculating antenna parameters

    if diff > 0:
        print(diff,'data out of',nrecd,'not used in analysis')

    # -------- calculate mean values in frequency bins ---------------
    if bname == 'All-Bands':
        xscale='log'
        if corx == 'Ca':
            yscale='linear'
        else:
            yscale='log'
        fmin=2.5
        fmax=40
    elif bname == 'High-Band':
        xscale='linear'
        yscale='linear'
        fmin=23
        fmax=32
    else:
        xscale='linear'
        yscale='linear'
        fmin=min([min(fres[0]), min(fres[1])])
        fmax=min([max(fres[0]), max(fres[1])])

    # --- calculate dipole antenna capacitance and resistance in vacuum
    xbin=int(fmax+2-fmin)
    freq=[0]*xbin
    Rvac=[0]*xbin
    Cvac=[0]*xbin

    # theoretical values of capacitance & resistance of DSX 3 wire dipole in vacuum
    La=80.0
    raa=0.2e-3
    for j in range(xbin):
        freq[j]=fmin+float(j)

        wlen=3.0e8/(freq[j]*1.0e3)
        Omega=pi2*freq[j]*1.0e3
        Rvac[j]=20.0*(pi*La/wlen)**2      # vacuum dipole resistance 1-wire
        Xvac=120.0*(np.log(La/(2.0*raa))-1.0)/np.tan(pi*La/wlen)
        Cvac[j]=1.0e12/(Omega*Xvac)       # vacuum dipole Capacitance 1- wire
        if comb == 'Yes':
            #double vacuum dipole Ca for one element & 3 wires
            Cvac[j]=Cvac[j]*3.0
            Rvac[j]=Rvac[j]/3.0
        else:
            Cvac[j]=2.0*Cvac[j]*3.0
            Rvac[j]=0.5*Rvac[j]/3.0

    print('Min & max vacuum Ca:',("{:8.2f}"*2).format(min(Cvac),max(Cvac)))

    for i in range(ndata):
        if i == 0:
            kb=0
        else:
            kb=3

       # if corx == 'Ca':
       #     axes[kb].plot(freq, Cvac, ls='dashed', lw=0.3, color='red')
       # else:
       #     ff=[2.7,33.0]
       #     XX=[160,18]
       #     axes[0].plot(ff, XX, ls='dashed', lw=0.3, color='black', label='Fitting')
       #     RR=[27,0.39]
       #     axes[1].plot(ff, RR, ls='dashed', lw=0.3, color='black', label='Fitting')

        #----- set axis properties for Ca or Xa------
        axes[kb].scatter(fres[i], CaXa[i], s=0.04, marker='+', color='black')
        axes[kb].set_xlim(fmin, fmax)
        axes[kb].set_xscale(xscale)
        axes[kb].set_ylim(minCX, maxCX)
        axes[kb].set_yscale(yscale)
        axes[kb].tick_params(axis='both',which='major',length=1.2,width=0.4, \
            pad=1,labelsize=2.5,left=True,right=True,bottom=True,top=True, \
            direction='in')
        axes[kb].tick_params(axis='both',which='minor',length=0.7,width=0.4, \
            pad=1,labelsize=0,left=True,right=True,bottom=True,top=True, \
            direction='in')
        axes[kb].set_xticklabels([])

        #----- set axis properties for Ra ------
        #note: / operator cannot be applied to list but can be used for numpy array
        axes[1+kb].scatter(fres[i], Ra[i], s=0.04, marker='+', color='black')
        axes[1+kb].set_xlim(fmin,fmax)
        axes[1+kb].set_xscale(xscale)
        axes[1+kb].set_yscale('log')
        axes[1+kb].set_ylim(minRa,maxRa)
        axes[1+kb].tick_params(axis='both',which='major',length=1.2,width=0.4, \
            pad=1,labelsize=2.5,left=True,right=True,bottom=True,top=True, \
            direction='in')
        axes[1+kb].tick_params(axis='both',which='minor',length=0.7,width=0.4, \
            pad=1,labelsize=0,left=True,right=True,bottom=True,top=True, \
            direction='in')
        axes[1+kb].set_xticklabels([])

        #----- set axis properties for pwr ------
        axes[2+kb].scatter(fres[i], pw[i], s=0.04, marker='+', color='black')
        axes[2+kb].set_xlim(fmin,fmax)
        axes[2+kb].set_xscale(xscale)
        axes[2+kb].set_yscale('log')
        axes[2+kb].set_ylim(minPr,maxPr)

        if bname == 'All-Bands':
            axes[2+kb].set_xticks([2.5,5,10,20,30,40])
            axes[2+kb].set_xticklabels(['2.5','5','10','20','30','40'])
        axes[2+kb].tick_params(axis='both',which='major',length=1.2,width=0.4, \
            pad=1,labelsize=2.5,left=True,right=True,bottom=True,top=True, \
            direction='in')
        axes[2+kb].tick_params(axis='both',which='minor',length=0.7,width=0.4, \
            pad=1,labelsize=0,left=True,right=True,bottom=True,top=True, \
            direction='in')
        axes[2+kb].set_xlabel('Resonance Frequency (kHz)',fontsize=3, \
            labelpad=0.7)

    # --- y-axis label
    if corx == 'Ca':
        axes[0].set_ylabel('$C_a$ (pF)',fontsize=3,labelpad=0.7)
    else:
        axes[0].set_ylabel('$-X_a$ ($10^{3}$ Ohm)',fontsize=3,labelpad=0.7)
    axes[1].set_ylabel('$R_a$ ($10^{3}$ Ohm)',fontsize=3,labelpad=0.7)
    axes[2].set_ylabel('$P_{out}$ (W)',fontsize=3,labelpad=0.7)

    # --- add text: date, inductance band, Y+ / Y - 1st harmonic ----
    datemax=max(date)
    datemin=min(date)
    if inpflag == 'In':
        txt=sL1+' Inside Nominal Plasmasphere'
    elif inpflag == 'Out':
        txt=sL1+' Outside Plasmasphere'
    else:
        txt=sL1+' All Regions'

    if comb == 'No':
        # make y-axis tick lables invisible for right panels
        for j in range(3,6):
            axes[j].set_yticklabels([])

        xloc=1.0
        axes[0].text(0,1.04,'Y+ 1st Harmonic',fontsize=2.5,ha='left',va='bottom', \
        transform=axes[0].transAxes)
        axes[3].text(1,1.04,'Y- 1st Harmonic',fontsize=2.5,ha='right',va='bottom', \
        transform=axes[3].transAxes)
    else:
        xloc=0.5
        #for j in range(3):
        #    axes[j].legend(loc='upper center',fontsize=1.6,bbox_to_anchor=(0.65,0.99), \
        #    frameon=False)

    axes[0].text(xloc,1.15,datemin[0:10]+'$ - $'+datemax[0:10],fontsize=3, \
        ha='center',va='bottom',transform=axes[0].transAxes)
    axes[0].text(xloc,1.04,txt,fontsize=3,ha='center',va='bottom', \
        transform=axes[0].transAxes)

    return canv, fig, toolbar
